<template>
    <div class="main">
        <div class="classe">
            <h1 style="margin-bottom: 120px"> <b>Designar Motoristas</b> </h1>
            <div class="form-row">
                <div class="form-group col-md-6">
                    <label for="inputDistancia4">Distância Pré Origem</label>
                    <input type="number" step="0.0005" class="form-control" id="inputDistancia4" placeholder="Distancia pré origem" v-model="viagem.dist_pre" readonly>
                </div>
                <div class="form-group col-md-6">
                    <label for="inputOrigem4">Distância Origem-Destino</label>
                    <input type="number" step="0.0005" class="form-control" id="inputOrigem4" placeholder="Distancia Origem-Destino" maxlength="11" v-model="viagem.dist_real" readonly>
                </div>
            </div>
            <div class="form-row">
                <div class="form-group col-md-4">
                    <label for="inputCityOrigem">Origem</label>
                    <input type="text" class="form-control" id="inputCityOrigem" v-model="viagem.origem" readonly>
                </div>
                <div class="form-group col-md-2">
                    <label for="inputParadasOrigem">Paradas Origem</label>
                    <input type="number" class="form-control" id="inputParadasOrigem" v-model="viagem.origem_estado" readonly>
                </div>
                <div class="form-group col-md-4">
                    <label for="inputCityDestino">Destino</label>
                    <input type="text" class="form-control" id="inputCityDestino" v-model="viagem.destino" readonly>
                </div>
                <div class="form-group col-md-2">
                    <label for="inputParadasDestino">Paradas Destino</label>
                    <input type="number" class="form-control" id="inputParadasDestino" v-model="viagem.destino_estado" readonly>
                </div>
            </div>
            <div class="form-row">
                <div class="form-group col-md-4">
                    <label for="inputOrcamento">Orçamento</label>
                    <input type="number" step="0.0005" class="form-control" id="inputOrcamento"  maxlength="11" v-model="viagem.orcamento" readonly>
                </div>
                <div class="form-group col-md-3">
                    <label for="inputDataSaida">Data de Saída</label>
                    <input type="date" id="inputDataSaida" class="form-control" v-model="viagem.data_s" readonly>
                </div>
                <div class="form-group col-md-3">
                    <label for="inputDataRetorno">Data de Retorno</label>
                    <input type="date" class="form-control" id="inputDataRetorno" v-model="viagem.data_r" readonly>
                </div>
                <div class='form-group col-md-2'>
                    <label for="inputHorarioSaida">Horário de Saída</label>
                    <input type="text" class="form-control" id="inputHorarioSaida" maxlength="15" v-model="viagem.hora_s" readonly>
                </div>
            </div>

            <h2 style="margin: 2%"> Adicionar </h2>
            <form @submit.prevent="salvar">
                <div class="form-row">
                    <div class="form-group col-md-3">
                        <label for="inputId">ID</label>
                        <input type="text" class="form-control" id="inputId" placeholder="id" v-model='motorista.id'>
                    </div>
                    <div class="form-group col-md-6">
                        <label for="inputName">CPF</label>
                        <input type="text" class="form-control" id="inputCPF" placeholder="CPF" v-model='motorista.cpf' disabled>
                    </div>
                    <div class="form-group col-md-3">
                        <button class="btn btn-success" style="margin-top: 32px">Enviar</button>
                    </div>
                </div>
            </form>
        </div>

        <table class="table" style="margin-top: 50px">
            <thead class="bg-success">
                <tr>
                    <th>ID</th>
                    <th>Nome</th>
                    <th>CPF</th>
                    <th>Ações</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="motorista of motoristas" :key="motorista.id">
                    <td>{{ motorista.id }}</td>
                    <td>{{ motorista.nome }}</td>
                    <td>{{ motorista.cpf }}</td>
                    <td> 
                        <button type="button" @click="remover(motorista)" class="btn btn-dark">Remover da Viagem</button>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</template>

<script>
    import Viagem from '../services/viagens'
    import axios from 'axios'
    import { httpGet } from '../services/config'

export default {

    data() {
        return {
            viagem: {
                id: '',
                passageiros: null,
                dist_pre: '',
                dist_real: '',
                origem: '',
                origem_estado: '',
                destino: '',
                destino_estado: '',
                orcamento: '',
                data_s: '',
                hora_s: '',
                data_r: ''
            },
            motorista: {
                id: '',
                viagem: null,
                nome: '',
                cpf: '',
                rg: '',
                disponivel: '',
                nascimento: '',
                telefone: '',
                endereco: '',
                cidade: '',
                categoria: '',
                obs: '',
                cnh: '',
                vencdocs: ''
            },
            viagens: [],
            motoristas: [],
            errors: [],
        }
    },
    
    mounted (){
        this.getV();
    },

    methods:{

        getV(){
            axios.get(httpGet() + '/viagens/' + this.$route.params.id).then(resposta => {
                console.log(resposta.data);
                this.viagem = resposta.data;
                this.motoristas = resposta.data.motoristas;
            });
        },
        async salvar() {
            let novoMotorista;
            
            axios.get(httpGet() + 'motoristas/' + this.motorista.id).then(resposta => {
                novoMotorista = resposta.data;
                console.log("Novo motora: " + novoMotorista);
                this.viagem.motoristas.push(novoMotorista);

                Viagem.atualizar(this.viagem).then(resposta => {
                        this.errors = []
                        this.motorista = {}
                        // window.location.reload()
                }).catch(e => {
                        this.errors = e.response.data.errors
                })
            }).catch(e => {
                alert("Erro de envio. Verifique se o ID do motorista existe.");
            })
        },
        Atualizar_Viagem () {
            Viagem.atualizar(this.viagem).then(resposta => {
                this.errors = []
                this.passageiro = {}
                // window.location.reload()
            }).catch(e => {
                this.errors = e.response.data.errors
            })
        },
        remover(motorista) {
            let vMotoristas = this.viagem.motoristas;
            for(let i = 0; i < vMotoristas.length; i++) {
                let obj = vMotoristas[i];
                if (obj["id"] == motorista["id"]) {
                    this.viagem.motoristas.splice(i,1);
                    this.Atualizar_Viagem();
                }
            }
        },
    }
}


</script>


<style>
    h1 {
        text-align: center;
        margin-top: 5%;
    }

    .classe {
        background-image: url('.././assets/icon_t.png');
        background-size: 150px;
        background-repeat: no-repeat;
    }
</style>